#include <iostream.h>
#define MaxNodes 4
#define B 1000

class Warshall
{
  private:
    unsigned Adj[MaxNodes][MaxNodes]; // .
    unsigned C[MaxNodes][MaxNodes];   // .
  public:
    void Vvod();
    void MinDlin();
    void Vyvod();
};

void Warshall::Vvod()
//       "".
{
  //    .
  cout <<"     :\n";
  for (int i=0;i<MaxNodes;i++)
    for (int j=0;j<MaxNodes;j++)
     {
       cout <<" Adj["<< (i+1) << "]["<< (j+1) << "]: ";
       cin >> Adj[i][j];
       if (Adj[i][j]==0) C[i][j] = B;
       else  C[i][j] = Adj[i][j];
     }
}

void Warshall::MinDlin()
//    .
{
  for (int k=0;k<MaxNodes;k++)
   for (int i=0;i<MaxNodes;i++)
    for (int j=0;j<MaxNodes;j++)
       if ( C[i][j]>C[i][k]+C[k][j] ) 
              C[i][j] = C[i][k]+C[k][j];
}

void Warshall::Vyvod()
//    .
{
  cout << "   :\n";
  for (int i=0;i<MaxNodes;i++)
  {
    for (int j=0;j<MaxNodes;j++)
      cout << C[i][j] << " ";
    cout << endl;
  }
}

void main()
{
  Warshall A;
  A.Vvod();
  A.MinDlin();
  A.Vyvod();
}
